{+---------------------------------------+}
{|                                       |}
{|         Bugsy Wabbit's Tree           |}
{|           Additional file             |}
{|         by Eugene Mayevski            |}
{|                                       |}
{|         http://i.am/Bugsy             |}
{|             Bugsy@i.am                |}
{+---------------------------------------+}

unit frmItemCol;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, BWTree, Mask, TypInfo, DsgnIntf;

type
  TItemColDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    StylesGB: TGroupBox;
    BoldCB: TCheckBox;
    ItCB: TCheckBox;
    ULCB: TCheckBox;
    Label2: TLabel;
    TextEdit: TEdit;
    StrikeCB: TCheckBox;
    ColorsCB: TCheckBox;
    StylesCB: TCheckBox;
    ColorsGB: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    ColTextMemo: TMemo;
    ColorCombo: TComboBox;
    BkColorCombo: TComboBox;
    Label3: TLabel;
    Label6: TLabel;
    IndexEdit: TEdit;
    Label7: TLabel;
    StIndexEdit: TEdit;
    procedure ColorsCBClick(Sender: TObject);
    procedure StylesCBClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Item: TBWTreeItem;
    ByCancel:boolean;
    procedure SetData;
    procedure GetData;
  end;

var
  ItemColDlg: TItemColDlg;

implementation

{$R *.DFM}

procedure TItemColDlg.SetData;
begin
  ColorCombo.Text:=ColorToString(Item.Color);
  BkColorCombo.Text:=ColorToString(Item.BkColor);
  ColorsCB.Checked:=Item.ParentColors;
  ColorsGB.Enabled:=not ColorsCB.Checked;
  StylesCB.Checked:=Item.ParentStyle;
  StylesGB.Enabled:=not StylesCB.Checked;
  TextEdit.Text:=Item.Text;
  ColTextMemo.Lines.Assign(Item.ColumnText);
  ItCB.Checked:=Item.Italic;
  ULCB.Checked:=Item.Underlined;
  BoldCB.Checked:=Item.Bold;
  StrikeCB.Checked:=Item.Strikeout;
  IndexEdit.Text:=IntToStr(Item.ImageIndex);
  StIndexEdit.Text:=IntToStr(Item.StateImageIndex);
end;

procedure TItemColDlg.GetData;
var I,J: integer;
    S  : string;
begin
  Item.ParentColors:=ColorsCB.Checked;
  if not ColorsCB.Checked then
  begin
    IdentToColor(ColorCombo.Text,i);
    Item.Color:=TColor(i);
    IdentToColor(BkColorCombo.Text,i);
    Item.BkColor:=TColor(i);
  end;
  Item.ParentStyle:=StylesCB.Checked;
  Item.Text:=TextEdit.Text;
  Item.ColumnText.Assign(ColTextMemo.Lines);
  Item.Italic:=ItCB.Checked;
  Item.Underlined:=ULCB.Checked;
  Item.Bold:=BoldCB.Checked;
  Item.Strikeout:=StrikeCB.Checked;
  S:=IndexEdit.Text;
  val(S,I,J);
  if J=0 then Item.ImageIndex:=I;
  S:=StIndexEdit.Text;
  val(S,I,J);
  if J=0 then Item.StateImageIndex:=I;
end;

procedure TItemColDlg.ColorsCBClick(Sender: TObject);
begin
  ColorsGB.Enabled:=not ColorsCB.Checked;
  ColorCombo.Enabled:=ColorsGB.Enabled;
  BkColorCombo.Enabled:=ColorsGB.Enabled;
end;

procedure TItemColDlg.StylesCBClick(Sender: TObject);
begin
  StylesGB.Enabled:=not StylesCB.Checked;
  ItCB.enabled:=StylesGB.Enabled;
  BoldCB.enabled:=StylesGB.Enabled;
  StrikeCB.enabled:=StylesGB.Enabled;
  ULCB.enabled:=StylesGB.Enabled;
end;

procedure TItemColDlg.FormCloseQuery(Sender: TObject;  var CanClose: Boolean);
var C:integer;
    s:string;
    i,j: integer;
begin
  if (ByCancel) or (ColorsCB.Checked) then
  begin
    CanClose:=true;
    exit;
  end;
  CanClose:=false;
  if IdentToColor(ColorCombo.Text,C) and IdentToColor(BkColorCombo.Text,C) then
  CanClose:=true else
  begin
    MessageBox(Handle,'Invalid color property','Error',mb_IconError or mb_Ok);
    ByCancel:=true;
    exit;
  end;
  S:=IndexEdit.Text;
  val(S,I,J);
  if J>0 then CanClose:=false;
  S:=StIndexEdit.Text;
  val(S,I,J);
  if J>0 then CanClose:=false;
  if not CanClose then
  begin
    MessageBox(Handle,'Invalid image index property','Error',mb_IconError or mb_Ok);
    ByCancel:=true;
  end;
end;

procedure TItemColDlg.OKBtnClick(Sender: TObject);
begin
  ByCancel:=false;
end;

procedure TItemColDlg.FormCreate(Sender: TObject);
begin
  ByCancel:=true;
end;

procedure TItemColDlg.CancelBtnClick(Sender: TObject);
begin
  ByCancel:=true;
end;

end.
